from typing import Any

from ..lib.lang.Integer import Integer

class Strings():
    def __init__(self) -> None:
        pass

    def equals(value1: str,value2: str) -> bool:
        if value1 is None: return value2 is None
        if value2 is None: return False
        return value1==value2

    def equalsIgnoreCase(value1: str,value2: str) -> bool:
        if value1 is None: return value2 is None
        if value2 is None: return False
        return value1.lower()==value2.lower()

    def startsWith(value: str,part: str) -> bool:
        return value.startswith(part)

    def endsWith(value: str,part: str) -> bool:
        return value.endsWith(part)
        
    def length(value: str) -> int:
        if value is None: return 0
        return len(value)
        
    def getLength(value: str) -> int:
        if value is None: return 0
        return len(value)

    def charCodeAt(value: str,index: int) -> int:
        if value is None: return 0
        return ord(value[index])

    def charCodeToString(code: int) -> str:
        return chr(code)

    def substring(value: str,ifrom: int,ito: int) -> str:
        return value[ifrom:ito]

    def substringFrom(value: str,ifrom: int) -> str:
        return value[ifrom:]

    def indexOf(value: str,part: str) -> int:
        return value.find(part)

    def indexOfFrom(value: str,part: str,index: int) -> int:
        return value.find(part,index)

    def toString(value: Any) -> str:
        if value is None: return "null"
        if isinstance(value,str): return value
        if hasattr(value,'toString'): return value.toString()
        return str(value)

    def toStringInt(value: Any) -> str:
        return str(value)

    def toStringDouble(value: Any) -> str:
        return str(value)
